#                    an example of script in sirc
#                          by orabidoo '95
#
#         _/_/_/_/_/  _/_/_/_/  _/_/_/      _/_/                  _/
#              _/    _/        _/    _/  _/    _/      _/_/_/    _/
#           _/      _/_/_/    _/_/_/    _/    _/      _/    _/  _/
#        _/        _/        _/    _/  _/    _/      _/    _/  _/
#     _/_/_/_/_/  _/_/_/_/  _/    _/    _/_/    _/  _/_/_/    _/
#                                                  _/
#                                                 _/
#
#      does all the missing applicable stuff from my ircII script zer0
#                    to load it in sirc, /load zer0.pl


$add_ons.="+zer0.pl" if ($add_ons !~ /zer0/);

$z_isaway='';
$z_awayfile=$ENV{"HOME"}."/.zer0-pl.mes";
$z_svefile=$ENV{"HOME"}."/.zer0-pl.sve";

$z_autoops=1;
$z_autorejoin=1;
$z_slowserver='';
@z_autooplist=();
$z_opdelay=5;

$z_pingmsg="I'm not lagged, but you surely are";

# time saving aliases

sub cmd_fing {
  &dosplat;
  &getarg;
  &sl("PRIVMSG $newarg :\caFINGER\ca") if $newarg;
}
&addcmd("fing");

sub cmd_ver {
  &dosplat;
  &getarg;
  &sl("PRIVMSG $newarg :\caVERSION\ca") if $newarg;
}
&addcmd("ver");

sub cmd_tim {
  &dosplat;
  &getarg;
  &sl("PRIVMSG $newarg :\caTIME\ca") if $newarg;
}
&addcmd("tim");

&docommand("^alias ex system");
&docommand("^alias ls system ls -al");
&docommand("^alias cat system cat");
&docommand("^alias rm system rm");
&docommand("^alias ps system ps");
&docommand("^alias mail system mail");

sub cmd_open {
  &getarg;
  $newarg=$talkchannel unless $newarg;
  &tell("*\cbE\cb* Huh? what channel?"), return unless $newarg;
  $newarg =~ tr/A-Z/a-z/;
  &sl("MODE $newarg -lsmpik ".$chankey{$newarg});
}
&addcmd("open");

sub cmd_sb {
  &dosplat;
  $args=$talkchannel unless $args;
  &sl("MODE $args b") if $args;
}
&addcmd("sb");

sub cmd_l {
  if ($talkchannel) {
    &sl("LIST $talkchannel");
    &sl("NAMES $talkchannel");
  }
}
&addcmd("l");

# dcc related stuff

&docommand("^alias ds dcc send");
&docommand("^alias dl dcc list");
&docommand("^alias cdc dcc close chat");
&docommand("^alias cdg dcc close get");
&docommand("^alias cds dcc close send");

sub cmd_dc {
  &getarg;
  if ($newarg) {
    &docommand("dcc chat $newarg");
  } elsif ($z_lastdc) {
    &docommand("dcc chat $z_lastdc");
    $z_lastdc='';
  }
}
&addcmd("dc");

sub cmd_dg {
  &getarg;
  if ($newarg) {
    &docommand("dcc get $newarg $args");
  } elsif ($z_lastdcc) {
    &docommand("dcc get $z_lastdcc");
    $z_lastdcc='';
  }
}
&addcmd("dg");

# hooks

sub hook_ctcp {
  if ($_[1] eq 'PING') {
    &sl("NOTICE $who :\caPONG ".$z_pingmsg."\ca");
  } elsif ($_[1] eq 'DCC') {
    $z_lastdcc=$who if $_[2] =~ /^SEND /;
    $z_lastdc=$who if $_[2] =~ /^CHAT /;
  }
}
&addhook("ctcp", "ctcp");

sub hook_kicked {
  local($kicked, $where_from, $reason)=@_;                           
  if ($z_autorejoin && &eq($kicked, $nick)) {
    &sl("JOIN $where_from");
  }
}
&addhook("kick", "kicked");

sub hook_uhnotify {
  unless ($z_slowserver) {
    &userhost($_[0], "&tell(\"*\cb)\cb* Signon by $_[0] (\$user\\\@\$host) detected!\");", "");
    $silent=1;
  }
} 
&addhook("notify_signon", "uhnotify");

# settings

sub cmd_rejoin {
  &getarg;
  $z_autorejoin=($newarg =~ /^on$/i) if ($newarg =~ /^on$|^off$/i);
  &tell("*\cbZ\cb* Auto-rejoin is ".($z_autorejoin?"on":"off"));
}
&addcmd("rejoin");

sub cmd_ss {
  &getarg;
  $z_slowserver=($newarg =~ /^on$/i) if ($newarg =~ /^on$|^off$/i);
  &tell("*\cbZ\cb* Slow-server is ".($z_slowserver?"on":"off"));
}
&addcmd("ss");

sub cmd_setping {
  $z_pingmsg=$args if $args;
  &tell("*\cbZ\cb* Your ping reply is: $z_pingmsg");
}
&addcmd("setping");

sub cmd_setfing {
  $finger=$args if $args;
  &tell("*\cbZ\cb* Your finger reply is: $finger");
}
&addcmd("setfing");

# ignores

sub cmd_ig {
  &docommand("ignore $args"), return if (!$args || $args =~ /^-/);
  &getarg;
  if ($newarg =~ /\@/) {
    $z_lastignore=$newarg;
    &docommand("ignore $newarg");
  } else {
    &userhost($newarg, "\$host=&z_hostpat(\$host); \$user =~ s/^\\~//; \$z_lastignore=\"*\$user\\\@\$host\"; &docommand(\"ignore *\$user\\\@\$host\");");
  }
}
&addcmd("ig");

sub cmd_unig {
  &docommand("ignore -$z_lastignore") if $z_lastignore;
  $z_lastignore='';
}
&addcmd("unig");

# bans and unbans

sub z_hostpat {
  if ($_[0] =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/) {
    return "${1}.${2}.${3}.*";
  } elsif ($_[0] =~ /^([^. \t]+)\.([^. \t]+)\.(.*)$/) {
    return "*.${2}.${3}";
  } else {
    return $_[0];
  }
}

sub cmd_kb {
  &getarg;
  local($why)=($args);
  $why="there must be a reason" unless $why;
  &tell("*\cbZ\cb* Must specify a nick to kickban"), return unless $newarg;
  &tell("*\cbZ\cb* You're not on a channel"), return unless $talkchannel;
  &userhost($newarg, "\$host=&z_hostpat(\$host); \$user =~ s/^\\~//;
&sl(\"MODE $talkchannel -o+b $newarg *!*\$user\\\@\$host\");
&sl(\"KICK $talkchannel $newarg :$why\");");
}
&addcmd("kb");

sub cmd_ban {
  &getarg;
  &tell("*\cbZ\cb* Must specify a nick to ban"), return unless $newarg;
  &tell("*\cbZ\cb* You're not on a channel"), return unless $talkchannel;
  &userhost($newarg, "\$host=&z_hostpat(\$host); \$user =~ s/^\\~//;
&sl(\"MODE $talkchannel +b *!*\$user\\\@\$host\");");
}
&addcmd("ban");

sub z_unbans {
  local($n, $l)=('0', '');
  foreach (@zer0_banlist) {
    if ($n<3) {
      $l.=" ".$_;
      $n++;
    } else {
      &sl("MODE $zer0_channel -bbb $l");
      $l=$_;
      $n=1;
    }
  }
  &sl("MODE $zer0_channel -".("b" x $n)." $l");
}

sub cmd_cb {
  &tell("*\cbZ\cb* You're not on a channel"), return unless $talkchannel;
  &addhook("367", "onecbban");
  &addhook("368", "donebans");
  @zer0_banlist=();
  $zer0_channel=$talkchannel;
  &sl("MODE $talkchannel b");
}
&addcmd("cb");

sub hook_onecbban {
  local($theban)=((split(/ +/, $_[0]))[2]);
  push(@zer0_banlist, $theban);
  $silent=1;
}

sub hook_donebans {
  &remhook("367", "onecbban");
  &remhook("367", "oneubban");
  &remhook("368", "donebans");
  &z_unbans;
}

sub cmd_unban {
  &getarg;
  &tell("*\cbZ\cb* Must specify a nick to unban"), return unless $newarg;
  &tell("*\cbZ\cb* You're not on a channel"), return unless $talkchannel;
  @zer0_banlist=();
  $zer0_channel=$talkchannel;
  &userhost($newarg, "&z_dounban;");
}
&addcmd("unban");

sub z_dounban {
  $z_pat=$who."!".$user."\@".$host;
  &addhook("367", "oneubban");
  &addhook("368", "donebans");
  @zer0_banlist=();
  $zer0_channel=$talkchannel;
  &sl("MODE $talkchannel b");
}

sub hook_oneubban {
  local($theban)=((split(/ +/, $_[0]))[2]);
  local($tb0)=($theban);
  $theban =~ s/([^\\])\./$1\\./g;
  $theban =~ s/\*/\.\*/g;
  $theban =~ s/([^\.\*\\\w])/\\$1/g;
  push(@zer0_banlist, $tb0) if ($z_pat =~ /^${theban}$/i);
  $silent=1;
}

sub cmd_fk {
  &getarg;
  &tell("*\cbZ\cb* Must specify a pattern to kick"), return unless $newarg;
  &tell("*\cbZ\cb* You're not on a channel"), return unless $talkchannel;
  $zer0_channel=$talkchannel;
  $zer0_kickpat=$newarg;
  $zer0_kickpat =~ s/([^\\])\./$1\\./g;
  $zer0_kickpat =~ s/\*/\.\*/g;
  $zer0_kickpat =~ s/([^\.\*\\\w])/\\$1/g;
  $zer0_kickmsg=$args || "though names may change each name retains the mask it wore";
  &addhook("352", "dofklist");
  &addhook("315", "donefk");
  &sl("WHO $talkchannel");
}
&addcmd("fk");

sub hook_dofklist {
  local($a)=@_;
  local($c, $c, $u, $h, $s, $n)=split(/ +/, $a);
  (($n."!".$u."\@".$h) =~ /${zer0_kickpat}/i) && 
    &sl("KICK $zer0_channel $n :$zer0_kickmsg");
  $silent=1;
}

sub hook_donefk {
  &remhook("352", "dofklist");
  &remhook("315", "donefk");
}

# the msg logger

sub cmd_setaway {
  !$z_isaway && open(ZAWAY, ">> ".$z_awayfile) && ($z_isaway=1);
  return unless $z_isaway;
  &me("is away - $args - messages will be logged");
  print ZAWAY "-- setaway : $args --\n";
  $args="\cb" if $args eq '';
  &sl("AWAY :$args");
}
&addcmd("setaway");

sub hook_messages {
  if ($z_isaway) {
    print ZAWAY ":\cb$who\cb: $_[0]\n";
    &sl("NOTICE $who :Your message has been logged - zer0.pl");
  }
} 
&addhook("msg", "messages");

sub hook_dmessages {
  print ZAWAY "=\cb".$_[0]."\cb= ".$_[1]."\n" if $z_isaway;
}
&addhook("dcc_chat", "dmessages");

sub cmd_setback {
  close(ZAWAY) if $z_isaway;
  $z_isaway='';
  &sl("AWAY");
  open(ZAWAY, "< ".$z_awayfile) || return;
  print while ($_=<ZAWAY>);
  close ZAWAY;
  &getuserline("*** Clear saved messages (y/n)? ", "clear? ");
  unlink ($z_awayfile) if /^y/i;
}
&addcmd("setback");

sub cmd_clearmes {
  close(ZAWAY) if $z_isaway;
  $z_isaway='';
  unlink ($z_awayfile);
}
&addcmd("clearmes");

# the autoop list, with fully-featured delayed and grouped auto-ops

sub z_addwaitop {
  local($nck, $channel)=@_;
  if ($z_opdelay) {
    local($n)=($nck);
    $channel =~ tr/A-Z/a-z/;
    $n =~ s/(\W)/\\$1/g;
    if ($z_waitops{$channel} !~ /:${n}:/i) {
      $z_waitops{$channel} || ($z_waitops{$channel}=":");
      $z_waitops{$channel}.=$nck.":";
    }
    unless ($z_timerdue) {
      $z_timerdue=1;
      &timer($z_opdelay, "&z_doautoops");
    }
  } else {
    &sl("MODE $channel +o $nck");
  }
}

sub z_remwaitop {
  local($nck, $channel)=@_;
  $channel =~ tr/A-Z/a-z/;
  $nck =~ s/(\W)/\\$1/g;
  $z_waitops{$channel} =~ s/:${nck}:/:/gi;
  delete $z_waitops{$channel} if $z_waitops{$channel} eq ":";
}

sub z_doautoops {
  local($l);
  foreach $c (keys(%z_waitops)) {
    if ($z_waitops{$c} ne ":" && $z_waitops{$c}) {
      $l=$z_waitops{$c};
      $l =~ s/^://;
      $l =~ s/:$//;
      $l =~ tr/:/ /;
      &docommand("o ".$c." ".$l);
    }
    delete $z_waitops{$c};
  }
  $z_timerdue='';
}

sub hook_z_nickchange {
  local($oldnick)=$who;
  $oldnick =~ s/(\W)/\\$1/g;
  foreach $c (keys(%z_waitops)) {
    $z_waitops{$c} =~ s/:${oldnick}:/:$_[0]:/gi;
  }
}
&addhook("nick", "z_nickchange");

sub hook_z_parted {
  &z_remwaitop($who, $_[0]);
}
&addhook("leave", "z_parted");

sub hook_z_quitted {
  local($w)=$who;
  $w =~ s/(\W)/\\$1/g;
  foreach $c (keys(%z_waitops)) {
    $z_waitops{$c} =~ s/:${w}:/:/gi;
    delete $z_waitops{$c} if $z_waitops{$c} eq ":";
  }
}
&addhook("signoff", "z_quitted");

sub hook_z_modechange {
# we only deal with +o, +oo and the like; the worst that can happen
# is that we op someone again
  local ($l)=$_[1];
  return unless $_[0] =~ /^[\#\&]/;
  return unless $l =~ s/^\+o+\s+//;
  foreach $n (split(/ /, $l)) {
    &z_remwaitop($n, $_[0]);
  }
}
&addhook("mode", "z_modechange");

sub autoopped {
  local($nuh)=@_;
  local($p);
  foreach $p (@z_autooplist) {
    return 1 if $nuh =~ /^${p}$/;
  }
  return '';
}

sub addtoops {
  if (&autoopped($who."!".$user."\@".$host)) {
    &tell("*\cbZ\cb* $who is already on your list");
  } else {
    $host=&z_hostpat($host);
    $user =~ s/^\~//;
    local($pat)=("*!*".$user."\@".$host);
    &tell("*\cbZ\cb* Adding $who as $pat to your autoop list");
    $pat =~ s/([^\\])\./$1\\./g;
    $pat =~ s/\*/\.\*/g;
    $pat =~ s/([^\.\*\\\w])/\\$1/g;
    push(@z_autooplist, $pat);
    &sl("NOTICE $who :You have been added to ${nick}'s autoop list");
    &sl("NOTICE $who :You should feel very honored");
  }
}

sub cmd_addop {
  &getarg;
  &tell("*\cbZ\cb* Must specify a nick or pattern"), return unless $newarg;
  if ($newarg =~ /\!.*\@/) {
    &tell("*\cbZ\cb* Adding $newarg to your auto-op list");
    $newarg =~ s/([^\\])\./$1\\./g;
    $newarg =~ s/\*/\.\*/g;
    $newarg =~ s/([^\.\*\\\w])/\\$1/g;
    push(@z_autooplist, $newarg);
  } else {
    &userhost($newarg, "&addtoops;");
  }
}
&addcmd("addop");

sub hook_joined {
  local($c)=($_[0]);
  $c =~ tr/A-Z/a-z/;
  &z_addwaitop($who, $c) 
    if ($z_autoops && $haveops{$c} && &autoopped($who."!".$user."\@".$host));
}
&addhook("join", "joined");

sub cmd_autoop {
  &getarg;
  if ($newarg =~ /^on$/) {
    $z_autoops=1;
  } elsif ($newarg =~ /^off$/) {
    $z_autoops='';
  }
  &tell("*\cbZ\cb* Auto-op is ".($z_autoops?"on":"off"));
}
&addcmd("autoop");

sub cmd_delay {
  $z_opdelay=$args if $args =~ /^\d+$/;
  &tell("*\cbZ\cb* Auto-op delay is set to: $z_opdelay");
}
&addcmd("delay");

sub cmd_listop {
  local($n, $p, $q)=(0);
  &tell("*\cbZ\cb* That's the people in your autoop list:");
  foreach $p (@z_autooplist) {
    $n++;
    $q=$p;
    $q =~ s/\\//g;
    $q =~ s/\.\*/*/g;
    &tell("*\cbZ\cb* $q");
  }
  &tell("*\cbZ\cb* which makes.. uhm... $n people, I think");
}
&addcmd("listop");

sub z_remop {
  local($nuh)=($who."!".$user."\@".$host);
  @z_autooplist=grep(($nuh !~ /^${_}$/), @z_autooplist);
}

sub cmd_remop {
  &getarg;
  if (!$newarg) {
    &tell("*\cbZ\cb* Must specify a nick or address");
  } elsif ($newarg =~ /\@/) {
    $newarg='*!'.$newarg if ($newarg !~ /\!/);
    &tell("*\cbZ\cb* Time to remove $newarg from the autoop list");
    @z_autooplist=grep(($newarg !~ /^${_}$/), @z_autooplist);
  } else {
    &tell("*\cbZ\cb* Time to remove $newarg from the autoop list");
    &userhost($newarg, "&z_remop;");
  }
}
&addcmd("remop");

sub cmd_clearop {
  @z_autooplist=();
  &tell("*\cbZ\cb* Auto-op list cleared!");
}
&addcmd("clearop");

# saving the settings

sub cmd_sve {
  local($p);
  if (!open(SVE, "> ".$z_svefile)) {
    &tell("*\cbE\cb* can't write to save file");
    return;
  }
  print SVE ($z_autoops ? "1" : "0"), "\n";
  print SVE ($z_autorejoin ? "1" : "0"), "\n";
  print SVE $z_pingmsg, "\n";
  print SVE $finger, "\n";
  print SVE join(" ", keys(%notify)), "\n";
  print SVE join(" ", @z_autooplist), "\n";
  print SVE ($z_slowserver ? "1" : "0"), "\n";
  print SVE $z_opdelay, "\n";
  close SVE;
  &tell("*\cbZ\cb* save completed!");
}
&addcmd("sve");

# some online help

sub cmd_zhelp {
  &docommand("help zer0".$args);
}
&addcmd("zhelp");

&addhelp("zer0", "This is \cbzer0.pl\cb for sirc, by \cborabidoo\cb
 
For the list of zer0.pl's general functions, type /zhelp general
For the list of zer0.pl's file functions, type /zhelp files
For the list of zer0.pl's settings, type /zhelp settings

Arguments between []'s are always optional.
 
For comments, bug reports, ideas:  email roger.espel.llima\@ens.fr");

&addhelp("zer0general", "List of \cbzer0.pl\cb's functions:

/ver <nick>             gets version info about <nick>
/tim <nick>             gets <nick>'s local time
/setaway <reason>       sets yourself away, logs messages
/setback                sets yourself back, shows messages
/clearmes               erases saved messages
/ig <nick>              ignores <nick>
/unig                   undoes your last /ig
/sb [<channel>]         shows ban list on a channel [current one]
/ban <nick>             bans on current channel
/unban <nick>           unbans on current channel
/cb                     clears all bans on current channel
/l                      short list of people on the current channel
/open [<channel>]       removes weird modes on the channel [current one]
/kb <nick> [<reason>]   kicks and bans
/fk <filter> [<reasn>]  kicks all users matching the filter
/sve                    saves your settings and auto-op and notify list");

&addhelp("zer0settings", "List of \cbzer0.pl\cb's settings:
/rejoin [on|off]        toggles auto-rejoin on kick
/autoop [on|off]        toggles auto-ops
/ss [on|off]            toggles slow-server mode (turn it on when you have
                        a slow connection with your server)
/setping [<message>]    set or see your ping reply
/setfing [<message>]    set or see your /ctcp finger reply
/addop <nick>|<pattrn>  adds user to your auto-op list
/remop <nick>|<address> removes user from your auto-op list
/clearop                clears your auto-op list
/listop                 lists your auto-op list
/delay			sets your auto-op delay
/sve                    saves your settings and auto-op and notify list");

&addhelp("zer0files", "List of \cbzer0.pl\cb's file-oriented functions:
/dc [<nick>]            starts a dcc chat [last offered]
/dg [<nick>] [<file>]   gets a file via dcc [last offered]
/ds <nick> <file>       sends a file via dcc
/cdc <nick>             closes a /dcc chat
/cds <nick>             closes a /dcc send connection
/cdg <nick>             closes a /dcc get connection
/ex <command>           \"shortcut\" for /system
/ls [<args>]            lists files
/cat <files>            shows files
/rm <files>             deletes files
/ps <options>           lists processes
/mail                   reads your mail  (you'll get disconnected from the
                        server if this takes more than a few minutes; exit
                        with 'q')");

# reading the saved settings

if (open(ZERORC, "< ".$z_svefile)) {
  local($n, $l);
  chop($z_autoops=<ZERORC>);
  chop($z_autorejoin=<ZERORC>);
  chop($z_pingmsg=<ZERORC>);
  chop($finger=<ZERORC>);
  chop($l=<ZERORC>);
  %notify=();
  foreach $n (split(' ', $l)) {
    &docommand("^NOTIFY ".$n);
  }
  chop($l=<ZERORC>);
  @z_autooplist=split(' ', $l);
  chop($z_slowserver=<ZERORC>);
  chop($z_opdelay=<ZERORC>);
  $z_opdelay=5 if $z_opdelay eq '';
  close(ZERORC);
}

&print("*\cbZ\cb* \cborabidoo\cb's *\cvzer0.pl\cv* for sirc loaded, type /zhelp for help");

